<div class="resource-box" #resourceBox>
  <div class="drop-release" [class.visible]="dragOver">
    <p class="mat-h2">Rilascia per caricare il file</p>
  </div>
  <p class="mat-h2">{{ title }}</p>
  <div
    class="properties mb"
    [class.isPreview]="mode === 'preview' && !newResource && canSave"
    (click)="
      !disabled && mode === 'preview' && !newResource && canSave
        ? (mode = 'edit')
        : null
    "
  >
    <ng-container
      *ngIf="mode === 'preview' && !newResource; else editProperties"
    >
      <button
        *ngIf="canSave && !disabled"
        [class.pointer]="!disabled"
        mat-mini-fab
        color="primary"
      >
        <mat-icon style="vertical-align: unset;">edit</mat-icon>
      </button>
      <p class="mat-h3 mb-0">
        <b>{{ resTitle }}</b>
      </p>
      <p class="mat-body">
        {{ resShortDescription }}
      </p>
      <p class="mat-body"><b>Tipo risorsa:</b> {{ labels[type] }}</p>
    </ng-container>
  </div>

  <ng-container
    *ngIf="
      !disabled &&
      (!single || (single && data[type] && data[type].length === 0))
    "
  >
    <mat-slide-toggle
      color="primary"
      [(ngModel)]="uploadVideos"
      *ngIf="type === 'videos'"
    >
      Carica video
    </mat-slide-toggle>
    <dbe-uploads
      titleText="Carica media"
      *ngIf="type !== 'videos' || (type === 'videos' && uploadVideos)"
      (uploaded)="uploaded($event)"
    ></dbe-uploads>
    <ng-container *ngIf="type === 'videos' && !uploadVideos">
      <div fxLayout="row wrap">
        <div fxFlex="100">
          <mat-form-field fxFlex="100" class="mt">
            <mat-label>Indirizzo video</mat-label>
            <input
              matInput
              placeholder="Indirizzo video"
              [(ngModel)]="newVideo.fullPath"
            />
          </mat-form-field>
        </div>
        <div fxFlex="100">
          <mat-form-field fxFlex="100" class="mt">
            <mat-label>Larghezza</mat-label>
            <input
              matInput
              placeholder="Larghezza"
              [(ngModel)]="newVideo.width"
            />
          </mat-form-field>
        </div>
        <div fxFlex="100">
          <mat-form-field fxFlex="100" class="mt">
            <mat-label>Altezza</mat-label>
            <input
              matInput
              placeholder="Altezza"
              [(ngModel)]="newVideo.height"
            />
          </mat-form-field>
        </div>
        <div fxFlex="100">
          <mat-checkbox
            (change)="newVideo.autoplay = !newVideo.autoplay"
            [checked]="newVideo.autoplay"
          >
            AutoPlay
          </mat-checkbox>
        </div>
        <div fxFlex="100" style="text-align: right;">
          <button mat-raised-button color="primary" (click)="uploaded()">
            Aggiungi video
          </button>
        </div>
      </div>
    </ng-container>
  </ng-container>
  <div *ngIf="!canSave">
    <p class="mat-body">
      Devi caricare almeno un elemento per salvare questa risorsa.
    </p>
  </div>
  <div
    *ngIf="canSave"
    class="resources mt"
    fxLayout="row wrap"
    fxLayoutGap="20px grid"
  >
    <div fxFlex="100">
      <p class="mat-h3"><b>Media caricati</b></p>
    </div>
    <div
      class="single-resource m5"
      [fxFlex]="100 / cols"
      *ngFor="let res of data[type]; let index = index"
    >
      <button
        *ngIf="!disabled"
        mat-mini-fab
        color="warn"
        class="delete scale"
        (click)="delete(index)"
      >
        <mat-icon style="vertical-align: unset;">delete</mat-icon>
      </button>
      <ng-container *ngIf="type === 'images'">
        <img class="image" [src]="basePath + res?.fullPath" alt="" />
      </ng-container>
      <ng-container *ngIf="type === 'videos'">
        <a
          *ngIf="!res.mimeType"
          [href]="res.fullPath"
          target="_blank"
          class="object-preview"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon fxFlex="100" style="color: #fff;"
            >play_circle_outline</mat-icon
          >
          <span style="color: #fff;" fxFlex="100">{{ res.fullPath }}</span>
        </a>
        <a
          *ngIf="res.mimeType"
          [href]="basePath + res.fullPath"
          target="_blank"
          class="object-preview"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon fxFlex="100" style="color: #fff;"
            >play_circle_outline</mat-icon
          >
          <span style="color: #fff;" fxFlex="100">{{ res.fileName }}</span>
        </a>
      </ng-container>
      <ng-container *ngIf="type === 'attachments'">
        <a
          [href]="basePath + res.fullPath"
          target="_blank"
          class="object-preview"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon fxFlex="100" style="color: #fff;">cloud_download</mat-icon>
          <span style="color: #fff;" fxFlex="100">{{ res.fileName }}</span>
        </a>
      </ng-container>
    </div>
  </div>
</div>
<!-- 
<div class="resource-box" [class.in-edit]="mode === 'edit'">
  <div
    fxLayout="row wrap"
    fxLayoutAlign="center center"
    fxLayoutGap="20px grid"
    *ngIf="mode === 'preview' && resource !== null; else editMode"
  >
    <div *ngIf="data && data.name" fxFlex>
      <b>{{ data.name.it || data.name.en }}</b>
    </div>
    <div fxFlex>{{ shortDescription() }}</div>
    <div fxFlex="nogrow" *ngIf="data && data[type] && data[type][0]">
      <ng-container *ngIf="type === 'images'">
        <img
          class="preview-image"
          [src]="
            basePath +
            'resources/square-preview/' +
            data._id +
            '/' +
            data[type][0].fullPath
          "
        />
      </ng-container>
      <ng-container *ngIf="type === 'videos'">
        <a
          [href]="data[type][0].fullPath"
          target="_blank"
          class="object-preview small"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon style="color: #fff;">play_circle_outline</mat-icon>
        </a>
      </ng-container>
      <ng-container *ngIf="type === 'attachments'">
        <a
          [href]="basePath + data[type][0].fullPath"
          target="_blank"
          class="object-preview small"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon style="color: #fff;">cloud_download</mat-icon>
        </a>
      </ng-container>
    </div>
    <div fxFlex="nogrow" *ngIf="data && data[type] && data[type].length > 1">
      <div
        class="preview-more"
        fxLayout="row wrap"
        fxLayoutAlign="center center"
      >
        <span fxFlex> +{{ data[type].length - 1 }} </span>
      </div>
    </div>
    <div fxFlex="nogrow">
      <button mat-mini-fab color="primary" (click)="mode = 'view'">
        <mat-icon style="vertical-align: unset;">remove_red_eye</mat-icon>
      </button>
    </div>
    <div fxLayout="nogrow">
      <button mat-mini-fab color="primary" (click)="mode = 'edit'">
        <mat-icon style="vertical-align: unset;">edit</mat-icon>
      </button>
    </div>
  </div>
  <div
    fxLayout="row wrap"
    fxLayoutAlign="center center"
    fxLayoutGap="20px grid"
    *ngIf="mode === 'view'"
  >
    <p
      fxFlexOrder="2"
      fxFlexOrder.gt-md="1"
      fxFlex="100"
      fxFlex.gt-md
      class="mat-h3"
      *ngIf="data && data.name"
    >
      <span class="label">Titolo Risorsa</span>
      {{ data.name.it || data.name.en }}
    </p>
    <p fxFlexOrder="3" fxFlexOrder.gt-md="2" fxFlex="100" fxFlex.gt-md>
      <ng-container *ngIf="data.description">
        <span class="label">Descrizione Risorsa</span>
        {{ data.description.it || data.description.en }}
      </ng-container>
    </p>
    <div
      fxFlexOrder="1"
      fxFlexOrder.gt-md="3"
      fxFlex="100"
      fxFlex.gt-md="nogrow"
    >
      <button mat-mini-fab color="primary" (click)="mode = 'preview'">
        <mat-icon style="vertical-align: unset;">close</mat-icon>
      </button>
    </div>
    <div
      fxFlexOrder="1"
      fxFlexOrder.gt-md="3"
      fxFlex="100"
      fxFlex.gt-md="nogrow"
    >
      <button mat-mini-fab color="primary" (click)="mode = 'edit'">
        <mat-icon style="vertical-align: unset;">edit</mat-icon>
      </button>
    </div>
  </div>
  <ng-template #editMode>
    <ng-container *ngIf="mode === 'edit'">
      <div fxLayout="row wrap" fxLayoutGap="20px grid">
        <ng-container *ngIf="i18n; else noI18n">
          <dbe-i18n-input
            *ngIf="data && data.name"
            fxFlex="100"
            fxFlex.gt-md="50"
            [(model)]="data.name"
            placeholder="Titolo Risorsa"
          >
          </dbe-i18n-input>
          <dbe-i18n-input
            *ngIf="data && data.description"
            fxFlex="100"
            fxFlex.gt-md="50"
            [(model)]="data.description"
            placeholder="Descrizione Risorsa"
          >
          </dbe-i18n-input>
        </ng-container>
        <mat-form-field fxFlex="100" *ngIf="types.length > 1">
          <mat-label *ngIf="label">Tipologia Risorsa</mat-label>
          <mat-select [(ngModel)]="type">
            <mat-option *ngFor="let type of types" [value]="type">
              {{ labels[type] }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <dbe-uploads
          titleText="Carica media"
          *ngIf="type !== 'videos'"
          (uploaded)="uploaded($event)"
        ></dbe-uploads>
        <ng-container *ngIf="type === 'videos'">
          <div fxFlex="100">
            <mat-form-field fxFlex="100" class="mt">
              <mat-label>Indirizzo video</mat-label>
              <input
                matInput
                placeholder="Indirizzo video"
                [(ngModel)]="newVideo.fullPath"
              />
            </mat-form-field>
          </div>
          <div fxFlex="100">
            <mat-form-field fxFlex="100" class="mt">
              <mat-label>Larghezza</mat-label>
              <input
                matInput
                placeholder="Larghezza"
                [(ngModel)]="newVideo.width"
              />
            </mat-form-field>
          </div>
          <div fxFlex="100">
            <mat-form-field fxFlex="100" class="mt">
              <mat-label>Altezza</mat-label>
              <input
                matInput
                placeholder="Altezza"
                [(ngModel)]="newVideo.height"
              />
            </mat-form-field>
          </div>
          <div fxFlex="100">
            <mat-checkbox
              (change)="newVideo.autoplay = !newVideo.autoplay"
              [checked]="newVideo.autoplay"
            >
              AutoPlay
            </mat-checkbox>
          </div>
          <div fxFlex="100" style="text-align: right;">
            <button mat-raised-button color="primary" (click)="uploaded()">
              Aggiungi video
            </button>
          </div>
        </ng-container>
      </div>
    </ng-container>
  </ng-template>
  <div
    class="resources mt"
    fxLayout="row wrap"
    fxLayoutGap="30px"
    *ngIf="mode !== 'preview' && resource !== null"
  >
    <div fxFlex="100">
      <p class="mat-h3"><b>Media caricati</b></p>
    </div>
    <div
      class="single-resource"
      fxFlex="nogrow"
      *ngFor="let res of data[type]; let index = index"
    >
      <button
        mat-mini-fab
        color="warn"
        class="delete"
        *ngIf="mode === 'edit'"
        (click)="delete(index)"
      >
        <mat-icon style="vertical-align: unset;">delete</mat-icon>
      </button>
      <ng-container *ngIf="type === 'images'">
        <img
          class="image"
          [src]="
            basePath +
            'resources/square-preview/' +
            data._id +
            '/' +
            res.fullPath
          "
          alt=""
        />
      </ng-container>
      <ng-container *ngIf="type === 'videos'">
        <a
          [href]="res.fullPath"
          target="_blank"
          class="object-preview"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon fxFlex="100" style="color: #fff;"
            >play_circle_outline</mat-icon
          >
          <span style="color: #fff;" fxFlex="100">{{ res.fullPath }}</span>
        </a>
      </ng-container>
      <ng-container *ngIf="type === 'attachments'">
        <a
          [href]="basePath + res.fullPath"
          target="_blank"
          class="object-preview"
          fxLayout="row wrap"
          fxLayoutAlign="center center"
        >
          <mat-icon fxFlex="100" style="color: #fff;">cloud_download</mat-icon>
          <span style="color: #fff;" fxFlex="100">{{ res.fileName }}</span>
        </a>
      </ng-container>
    </div>
  </div>
  <div style="text-align: right;" class="mt" *ngIf="mode === 'edit'">
    <button mat-raised-button color="primary" (click)="update(true)">
      Salva Risorsa
    </button>
  </div>
</div>

<ng-template #noI18n>
  <mat-form-field fxFlex="100" class="mt">
    <mat-label>Titolo Risorsa</mat-label>
    <input
      matInput
      placeholder="Titolo Risorsa"
      [(ngModel)]="data.name"
      fxFlex.gt-md="50"
    />
  </mat-form-field>
  <mat-form-field fxFlex="100" class="mt">
    <mat-label>Descrizione Risorsa</mat-label>
    <input
      matInput
      placeholder="Descrizione Risorsa"
      [(ngModel)]="data.description"
      fxFlex.gt-md="50"
    />
  </mat-form-field>
</ng-template> -->

<ng-template #editProperties>
  <div
    fxLayout="row wrap"
    fxLayoutAlign="center center"
    fxLayoutGap="20px grid"
  >
    <ng-container *ngIf="i18n; else noI18n">
      <dbe-i18n-input
        *ngIf="data && data.name"
        fxFlex="100"
        [(model)]="data.name"
        [placeholder]="'Titolo ' + (title | lowercase)"
      >
      </dbe-i18n-input>
      <dbe-i18n-input
        *ngIf="data && data.description"
        fxFlex="100"
        [(model)]="data.description"
        [placeholder]="'Descrizione ' + (title | lowercase)"
      >
      </dbe-i18n-input>
    </ng-container>
    <mat-form-field fxFlex="100" *ngIf="types.length > 1">
      <mat-label *ngIf="label">Tipologia Risorsa</mat-label>
      <mat-select [(ngModel)]="type">
        <mat-option *ngFor="let type of types" [value]="type">
          {{ labels[type] }}
        </mat-option>
      </mat-select>
    </mat-form-field>
    <div fxFlex="100" style="text-align: right;" *ngIf="!newResource">
      <button mat-stroked-button color="primary" (click)="update(true)">
        Salva proprietà
      </button>
    </div>
  </div>
</ng-template>

<ng-template #noI18n>
  <mat-form-field fxFlex="100">
    <mat-label>Titolo {{ title | lowercase }}</mat-label>
    <input
      matInput
      [placeholder]="'Titolo ' + (title | lowercase)"
      [(ngModel)]="data.name"
    />
  </mat-form-field>
  <mat-form-field fxFlex="100">
    <mat-label>Descrizione {{ title | lowercase }}</mat-label>
    <input
      matInput
      [placeholder]="'Descrizione ' + (title | lowercase)"
      [(ngModel)]="data.description"
    />
  </mat-form-field>
</ng-template>
